/**************************************
*	This class encapsulates a vector		*
*	function and is capable of several	*
*	vector operations.									*
**************************************/
#include <math.h>

class Vector
{
	public:
	float x;
	float y;
	float z;
	
	public:
	Vector()																															//constructor
	{
		x=y=z=0;																														//set default values to zero
	}
	
	float Dot(Vector v);																									//computes the dot product
	Vector Plus(Vector v);																								//function returns the sum of two vectors
	Vector Minus(Vector v);																								//function returns the difference of two vectors
	Vector Cross(Vector v);																								//function returns the cross product of two vectors
	Vector Times(float num);
	float getX(){return x;}
	float getY(){return y;}
	float getZ(){return z;}
	void Normalize();
	float Length();
	void setCoords(float x, float y, float z);

};	//end class Vector



float Vector::Dot(Vector v)																										//computes the dot product
	{
		float sum;																													//create variable
		sum=x*v.x + y*v.y + z*v.z;														//calculate dot product
		return sum;																													//return dot product
	}
	
Vector Vector::Plus(Vector v)																									//function returns the sum of two vectors
	{
		Vector sum;																													//create variable
		sum.x=x+v.x;																												//add vectors
		sum.y=y+v.y;
		sum.z=z+v.z;
		return sum;																													//return the result
	}
	
Vector Vector::Minus(Vector v)																								//function returns the difference of two vectors
	{
		Vector diff;																												//create variable
		diff.x=x-v.x;																												//subtract vectors
		diff.y=y-v.y;
		diff.z=z-v.z;
		return diff;																												//return value
	}
	
Vector Vector::Times(float num)																							//multiplies a vector by a constant
{
	Vector scaled;
	scaled.x=x*num;
	scaled.y=y*num;
	scaled.z=z*num;
	return scaled;	
}

Vector Vector::Cross(Vector v)																								//function returns the cross product of two vectors
	{
		Vector ortho;																												//create an object
		ortho.x=y*v.z - z*v.y;																							//calculate cross product
		ortho.y=z*v.x - x*v.z;
		ortho.z=x*v.y - y*v.x;
		return ortho;																												//return value
	}

float Vector::Length()																									//returns the length of the vector
{
	double length=sqrt(x*x + y*y + z*z);
	return length;
}

void Vector::Normalize()																								//makes the vector a unit vector
{
	float length=sqrt(x*x + y*y + z*z);																		//find the length of the vector
	if(length<0.1) return;
	x=x/length;																														//divide each vector by the length
	y=y/length;
	z=z/length;
}
void Vector::setCoords(float v1, float v2, float v3)												//function sets the vector coordinates
	{
		x=v1;
		y=v2;
		z=v3;
	}

